IdexBot/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic import TemplateView

urlpatterns = [
    path(r'', TemplateView.as_view(template_name='index.html')),
    path(r'tgb', TemplateView.as_view(template_name='tg_manage.html')),
    path(r'admin/', admin.site.urls),
    path(r'api/', include(('main.urls', 'main'), namespace='main')),
    path(r'tg_bot/', include(('tg_bot.urls', 'tg_bot'), namespace='tg_bot')),
    path(r'api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    path(r'rest-auth/', include('rest_auth.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

main/urls.py
from django.urls import path
from rest_framework.routers import SimpleRouter

from .views import BotView, UserView, MessagesView

router = SimpleRouter()
router.register(r'bot', BotView)
router.register(r'user', UserView)
urlpatterns = [
                  path(r'messages', MessagesView.as_view(), name='messages')
              ] + router.urls

tg_bot/urls.py
from django.urls import path
from rest_framework.routers import SimpleRouter

from .views import TGAccountViewSet, PhoneCodeView, TaskTGView

router = SimpleRouter()
router.register(r'tg_acc', TGAccountViewSet)
urlpatterns = [
                  path(r'phone_code', PhoneCodeView.as_view(), name='phone_code'),
                  path(r'task', TaskTGView.as_view(), name='task')
              ] + router.urls

main/models.py
from django.contrib.auth.models import AbstractUser
from django.core.validators import MaxValueValidator
from django.db import models
from django.utils import timezone


class User(AbstractUser):
    api_key = models.CharField(max_length=100)
    secret = models.CharField(max_length=100)
    exchange = models.CharField(max_length=20, default='binance')
    is_tg_manage = models.BooleanField(default=False)
    is_crypto_manage = models.BooleanField(default=False)


class Bot(models.Model):
    owner = models.ForeignKey(User, on_delete=models.CASCADE)
    sum_field = models.FloatField('Начальная сумма закупа/продажи(Sum)')
    adv = models.FloatField('Adv', validators=[MaxValueValidator(100)])
    side_field = models.CharField(max_length=4)
    type_field = models.CharField(max_length=6)
    is_active = models.BooleanField(default=False)
    date = models.DateTimeField('Время создания бота', default=timezone.now)
    market = models.CharField(max_length=12)
    limit_price = models.FloatField('Макс(закуп) или мин(продажа) цена')
    rival = models.PositiveSmallIntegerField('Rival',
                                             validators=[
                                                 MaxValueValidator(100)])

    sum1_field = models.FloatField('Оставшаяся сумма закупа/продажи(Sum1)',
                                   null=True)
    start_price = models.FloatField('Начальная цена', null=True)

    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        self.sum1_field = self.sum_field
        super(Bot, self).save(force_insert, force_update, using, update_fields)


class Order(models.Model):
    bot = models.ForeignKey(Bot, on_delete=models.CASCADE)
    order_id = models.CharField(max_length=200, blank=True)

tg_bot/models.py
from django.db import models

from main.models import User


class TGBot(models.Model):
    owner = models.ForeignKey(User, on_delete=models.CASCADE)
    api_id = models.CharField(max_length=20)
    api_hash = models.CharField(max_length=100)
    phone_number = models.CharField(max_length=20)
    password = models.CharField(max_length=200, blank=True)

main/views.py
from rest_framework import viewsets, views, permissions
from rest_framework.response import Response
from user_messages import api as messages

from .models import Bot, User
from .permissions import IsOwner, IsCryptoManage
from .serializers import BotSerializer, UserSerializer


class BotView(viewsets.ModelViewSet):
    queryset = Bot.objects.all()
    serializer_class = BotSerializer
    permission_classes = (IsOwner, IsCryptoManage,)

    def perform_create(self, serializer):
        serializer.save(owner=self.request.user)

    def get_queryset(self):
        """
        This view should return a list of all the purchases for
        the user as determined by the username portion of the URL.
        """
        user = self.request.user
        return self.queryset.filter(owner=user)


class UserView(viewsets.ModelViewSet):
    queryset = User.objects.all()
    serializer_class = UserSerializer


class MessagesView(views.APIView):
    permission_classes = (permissions.IsAuthenticated,)

    def get(self, request, format=None):
        user = User.objects.get(pk=request.user.id)
        msgs = messages.get_messages(user=user)
        msgs = sorted(msgs, key=lambda x: x.created_at)[-10:]
        result = []
        for msg in msgs:
            result.append({'message': msg.message, 'status': msg.level_tag,
                           'time': msg.created_at})
        return Response({'messages': result})

tg_bot/views.py
from random import randint

import redis
from django.conf import settings
from rest_framework import viewsets, views, status
from rest_framework.response import Response

from main.permissions import IsOwner
from .models import TGBot
from .permissions import IsTGManager
from .serializers import TGAccountSerializer
from .tasks import tg_join, tg_leave, tg_message


class TGAccountViewSet(viewsets.ModelViewSet):
    queryset = TGBot.objects.all()
    permission_classes = (IsOwner, IsTGManager)
    serializer_class = TGAccountSerializer

    def perform_create(self, serializer):
        serializer.save(owner=self.request.user)

    def get_queryset(self):
        """
        This view should return a list of all the purchases for
        the user as determined by the username portion of the URL.
        """
        user = self.request.user
        return self.queryset.filter(owner=user)


class PhoneCodeView(views.APIView):

    def post(self, request, format=None):
        r = redis.StrictRedis(host=settings.REDIS_HOST,
                              port=settings.REDIS_PORT, db=settings.REDIS_DB)
        r.set('phone_code {}'.format(request.data['phone_number']),
              request.data['phone_code'])
        tg_status = None
        while not tg_status:
            tg_status = r.get(
                'phone_code_status {}'.format(request.data['phone_number']))
        r.delete('phone_code_status {}'.format(request.data['phone_number']))
        return Response(data=tg_status,
                        status=status.HTTP_200_OK if tg_status == b'Ok' else status.HTTP_400_BAD_REQUEST)


class TaskTGView(views.APIView):
    permission_classes = (IsTGManager,)

    def post(self, request, format=None):
        actions = {
            'join': tg_join,
            'leave': tg_leave,
            'message': tg_message
        }
        accounts = TGBot.objects.filter(owner=request.user)
        if request.data['min_time']:
            min_time = int(request.data['min_time'])
        else:
            min_time = None
        if request.data['max_time']:
            max_time = int(request.data['max_time'])
        else:
            max_time = None
        if min_time and max_time:
            countdown = randint(min_time,
                                max_time)
        elif min_time or max_time:
            countdown = min_time or max_time
        else:
            countdown = 0
        for account in accounts:
            if request.data['action'] == 'message':
                actions[request.data['action']].apply_async(
                    (request.user.pk, account.pk,
                     request.data['group'],
                     request.data['message']),
                    countdown=countdown)
            else:
                actions[request.data['action']].apply_async(
                    (request.user.pk, account.pk,
                     request.data['group']),
                    coundown=countdown)
            if min_time and max_time:
                countdown += randint(min_time,
                                     max_time)
            elif min_time or max_time:
                countdown += min_time or max_time
        return Response('Ok')

templates/index.html
{% load static i18n %}
<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Crypto Bot</title>
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}"
          type="text/css">
    <link rel="stylesheet" href="{% static 'css/fontawesome-all.css' %}"
          type="text/css">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
</head>
<body>
<div class="container">
  {% if request.user.is_authenticated %}
    {% include 'main.html' %}
  {% else %}
    {% include 'login.html' %}
  {% endif %}
</div>
  <script src="{% static 'js/jquery-3.3.1.min.js' %}"></script>
  <script src="{% static 'js/popper.min.js' %}"></script>
  <script src="{% static 'js/bootstrap.min.js' %}"></script>
  <script src="{% static 'js/main.js' %}"></script>
  {% if request.user.is_authenticated %}
    <script src="{% static 'js/auth.js' %}"></script>
  {% endif %}
</body>
</html>

templates/login.html
    <form class="form-horizontal ajax-post" role="form"
          action="{% url 'rest_login' %}" method="post" id="form-login">
      <div class="form-group">
        <label for="username" class="col-sm-2 control-label">Username</label>
        <div class="col-sm-10">
          <input name="username" type="text" class="form-control" id="username"
                 placeholder="Username">
        </div>
      </div>

      <div class="form-group">
        <label for="password" class="col-sm-2 control-label">Password</label>
        <div class="col-sm-10">
          <input name="password" type="password" class="form-control"
                 id="password"
                 placeholder="Password">
        </div>
      </div>

      <div class="form-group">
        <div class="col-sm-offset-2 col-sm-10">
          <button type="submit" class="btn btn-default">Login</button>
        </div>
      </div>
      <div class="form-group response"></div>
    </form>

templates/main.html
<div class="table-responsive col-10 table-bots">
    <table class="table table-hover">
      <thread>
        <tr>
          <th>ID</th>
          <th>Market</th>
          <th>Sum1</th>
          <th>Date</th>
          <th></th>
        </tr>
      </thread>
      <tbody id="bots">
        <tr class="crete-new">
          <th colspan="6"><button class="btn btn-default create-bot"
                                  data-toggle="collapse"
                                  data-target="#form-bot" aria-expanded="false">
            <i class="fas fa-plus"></i> Create new bot</button></th>
        </tr>
      </tbody>
    </table>
  </div>
    <div class="col-1 box">
      <form class="ajax-post" role="form"
            action="{% url 'rest_logout' %}" method="post" id="logout">
        <button type="submit" class="btn btn-default">Logout</button>
        <div class="form-group response"></div>
      </form>
      <div class="login">username: {{ request.user.username }}</div>
      <br>
    </div>
    <div class="col-1 box">
      <div class="notification">
        <i class="fas fa-bell"></i>
        <span class="num"></span>
        <ul id="messages">
        </ul>
      </div>
    </div>

    <form class="ajax-post col-2" role="form"
          action="{% url 'main:user-detail' request.user.id %}" method="put"
          id="form-crypto">
      {#  Форма обновления API ключа  #}
      <div class="form-group required">
        <label class="control-label" for="api_key">api_key </label>
        <input type="text" name="api_key" class="form-control" id="api_key"
               required>
      </div>
      <div class="form-group required">
        <label class="control-label" for="secret">secret </label>
        <input type="text" name="secret" class="form-control" id="secret"
               required>
      </div>
      <button type="submit" class="btn btn-default">Edit api</button>
      <div class="form-group response"></div>
    </form>

    <form method="post" action="{% url 'main:bot-list' %}" name="create-bot"
          class="form-horizontal ajax-post collapse col-10"
          aria-expanded="false" id="form-bot">
      {#  Форма создания бота  #}
      <div class="form-group required">
        <label class="control-label col-sm-2" for="market">Market </label>
        <input type="text" maxlength="12" name="market" class="form-control"
               id="market" required>
      </div>
      <div class="form-group required">
        <label class="control-label col-sm-2" for="sum">Sum </label>
        <input type="number" name="sum_field" class="form-control" id="sum"
               step="0.001"
               required>
      </div>
      <div class="form-group">
        <label class="control-label col-sm-2"
               for="start-price">StartPrice </label>
        <input type="number" name="start_price" class="form-control" step="any"
               id="start-price">
      </div>
      <div class="form-group required">
        <label class="control-label col-sm-2"
               for="limit-price">LimitPrice </label>
        <input type="number" name="limit_price" class="form-control"
               id="limit-price" step="any" required>
      </div>
      <div class="form-group required">
        <label class="control-label col-sm-2" for="rival">Rival </label>
        <input type="number" name="rival" class="form-control" id="rival"
               step="any"
               required>
      </div>
      <div class="form-group required">
        <label class="control-label col-sm-2" for="adv">Adv </label>
        <input type="number" name="adv" class="form-control" id="adv" step="any"
               required>
      </div>
      <div class="form-group required">
        <label class="control-label col-sm-2" for="side_field">Side </label>
        <select name="side_field" class="form-control" id="side_field" required>
          <option value="sell">Sell</option>
          <option value="buy" selected>Buy</option>
        </select>
      </div>
      <div class="form-group required" hidden>
        <label class="control-label col-sm-2" for="type_field">Type </label>
        <select name="type_field" class="form-control" id="type_field" required>
          <option value="market">Market</option>
          <option value="limit" selected>Limit</option>
        </select>
      </div>
      <button type="submit" class="btn btn-default">Create bot</button>
      <div class="form-group response"></div>
    </form>

templates/tg_manage.html
{% load static i18n %}
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <title>TG Bots</title>
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}"
          type="text/css">
    <link rel="stylesheet" href="{% static 'css/fontawesome-all.css' %}"
          type="text/css">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
</head>
<body>
<div class="container">
  {% if request.user.is_authenticated %}
    <dev class="col-8 tg-content">
      <form role="form" action="{% url 'tg_bot:task' %}" id="form-action" method="post">
        <div class="form-row">
          <div class="col form-group required">
            <label for="group" class="control-label">Group</label>
            <input type="text" name="group" class="form-control" id="group"
                   placeholder="Group*" required>
          </div>
          <div class="col form-group">
            <label for="message">Message</label>
            <input type="text" name="message" class="form-control" id="message"
                   placeholder="Message">
          </div>
        </div>
        <div class="form-row">
          <div class="col form-group">
            <label for="min_time">Min time between message, join or leave</label>
            <input type="number" name="min_time" class="form-control" id="min_time"
                   placeholder="Min time">
          </div>
          <div class="col form-group">
            <label for="max_time">Max time between message, join or leave</label>
            <input type="number" name="max_time" class="form-control" id="max_time"
                   placeholder="Max time">
          </div>
        </div>
        <div class="form-group required">
          <div class="control-label">Action</div>
          <div class="form-check">
            <input class="form-check-input" type="radio" name="action" id="inlineRadio1" value="join" checked>
            <label class="form-check-label" for="inlineRadio1">Join group</label>
          </div>
          <div class="form-check">
            <input class="form-check-input" type="radio" name="action" id="inlineRadio2" value="message">
            <label class="form-check-label" for="inlineRadio2">Send message</label>
          </div>
          <div class="form-check">
            <input class="form-check-input" type="radio" name="action" id="inlineRadio3" value="leave">
            <label class="form-check-label" for="inlineRadio3">Leave group</label>
          </div>
        </div>
        <div class="form-group">
          <button type="submit" class="btn btn-default">Submit</button>
          <div class="form-group response"></div>
        </div>
      </form>
      <form role="form" action="/tg_bot/tg_acc/" id="tg-account-form" method="post">
        <div class="form-row">
          <div class="col form-group required">
            <label for="phone_number" class="control-label">Phone number</label>
            <input type="text" class="form-control" id="phone_number"
                   name="phone_number" placeholder="Phone number*">
          </div>
        <div class="col form-group">
          <label for="password" class="control-label">Password</label>
          <input type="text" class="form-control" id="password" name="password"
                 placeholder="Password">
          </div>
        </div>
        <div class="form-row">
          <div class="col form-group required">
            <label for="api_id" class="control-label">api_id</label>
            <input type="text" class="form-control" id="api_id" name="api_id"
                   placeholder="api_id">
          </div>
          <div class="col form-group required">
            <label for="api_hash" class="control-label">api_hash</label>
            <input type="text" class="form-control" id="api_hash"
                   name="api_hash" placeholder="api_hash">
          </div>
        </div>
        <button type="submit" class="btn btn-default">Add account</button>
        <div class="form-group response"></div>
      </form>
      <form role="form" class="collapse" id="phone_code_form" action="{% url 'tg_bot:phone_code' %}" method="post">
        <div class="form-row col-5 form-group">
          <div class="col">
            <input type="text" class="form-control" name="phone_code"
                   placeholder="Phone code">
          </div>
        <button type="submit" class="btn btn-default">Confirm</button>
        <div class="form-group response"></div>
        </div>
      </form>
    </dev>
    <div class="col-4 tg-content">

      <div class="col-3 box">
        <form class="ajax-post" role="form"
              action="{% url 'rest_logout' %}" method="post" id="logout">
          <button type="submit" class="btn btn-default">Logout</button>
          <div class="form-group response"></div>
        </form>
        <div class="login">username: {{ request.user.username }}</div>
      </div>
      <div class="col-6 box">
        <button class="btn btn-default show-accounts"
                data-toggle="collapse"
                data-target="#table-accounts" aria-expanded="false">
              <i class="fas fa-plus"></i> Show accounts</button>

        <div class="table-responsive table-accounts collapse" id="table-accounts"
             aria-expanded="false">
          <table class="table">
            <thread>
              <tr>
                <th>ID</th>
                <th>Phone</th>
                <th></th>
              </tr>
            </thread>
            <tbody id="accounts">
            </tbody>
          </table>
        </div>
      </div>
      <div class="col-2 box">
        <div class="notification">
          <i class="fas fa-bell"></i>
          <span class="num"></span>
          <ul id="messages">
          </ul>
        </div>
      </div>
    </div>
  {% else %}
    {% include 'login.html' %}
  {% endif %}
</div>
  <script src="{% static 'js/jquery-3.3.1.min.js' %}"></script>
  <script src="{% static 'js/popper.min.js' %}"></script>
  <script src="{% static 'js/bootstrap.min.js' %}"></script>
  <script src="{% static 'js/main.js' %}"></script>
  {% if request.user.is_authenticated %}
    <script src="{% static 'js/auth_tg.js' %}"></script>
  {% endif %}
  </body>
</html>